
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _INTERIOR_H_
#define _INTERIOR_H_


#pragma once

#include "Range.h"

/*
CInterior class represents Excel outline object by using OpenOffice.
It implements IInterior COM interface.
*/

namespace AutomateIT
{
    namespace ExcelClone
    {

        class ATL_NO_VTABLE CInterior :
            public CComObjectRootEx<CComSingleThreadModel>,
            public CDispatchHook<IDispatchImpl<Interior, &IID_Interior, &LIBID_ExcelCloneLib, 1, 0> >
        {
        public:
            CInterior();
            virtual ~CInterior();

            BEGIN_COM_MAP(CInterior)
                COM_INTERFACE_ENTRY(Interior)
                COM_INTERFACE_ENTRY(IDispatch)
            END_COM_MAP()

        public:

            HRESULT __stdcall get_Application( 
                _Application **RHS);

            HRESULT __stdcall get_Creator( 
                XlCreator *RHS);

            HRESULT __stdcall get_Parent( 
                IDispatch **RHS);

            HRESULT __stdcall get_Color( 
                VARIANT *RHS);

            HRESULT __stdcall put_Color( 
                VARIANT RHS);

            HRESULT __stdcall get_ColorIndex( 
                VARIANT *RHS);

            HRESULT __stdcall put_ColorIndex( 
                VARIANT RHS);

            HRESULT __stdcall get_InvertIfNegative( 
                VARIANT *RHS);

            HRESULT __stdcall put_InvertIfNegative( 
                VARIANT RHS);

            HRESULT __stdcall get_Pattern( 
                VARIANT *RHS);

            HRESULT __stdcall put_Pattern( 
                VARIANT RHS);

            HRESULT __stdcall get_PatternColor( 
                VARIANT *RHS);

            HRESULT __stdcall put_PatternColor( 
                VARIANT RHS);

            HRESULT __stdcall get_PatternColorIndex( 
                VARIANT *RHS);

            HRESULT __stdcall put_PatternColorIndex( 
                VARIANT RHS);

        public:

            HRESULT __stdcall Initialize(CRangePtr pPange);

        private:

            CRangePtr m_pRange;

        };

        typedef CComObject<CInterior> CInteriorObject;
        typedef CComPtr<CInterior> CInteriorPtr;

    }
}
#endif // _INTERIOR_H_