; AutomateIT installer file

;--------------------------------
; The name of the installer
Name "AutomateIT"

!include 'LogicLib.nsh'

; The file to write


  !ifdef DEBUG
	!define BUILDTYPE "debug"
	!define EXENAME "..\..\Bin\Installer\AutomateIT_debug.exe"        
  !else
	!define BUILDTYPE "release"
	!define EXENAME "..\..\Bin\Installer\AutomateIT!.exe"
  !endif 


InstallDir $PROGRAMFILES\AutomateIT!
OutFile ${EXENAME}


;--------------------------------

; Pages

Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

Section "Install" 

  ; check for MS Office Word and if it isn't found, install WordClone
  ReadRegStr $0 HKCR "CLSID\{000209FF-0000-0000-C000-000000000046}" ""

  ; check for MS Office Excel and if it isn't found, install ExcelClone
  ReadRegStr $1 HKCR "CLSID\{00024500-0000-0000-C000-000000000046}" ""

  ${If} $0 == ""
  ${Orif} $1 == ""
    SetOutPath $INSTDIR
    File cloner.ini
    WriteUninstaller "uninstall.exe"
    WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\AutomateIT!" "DisplayName" "AutomateIT!"
    WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\AutomateIT!" "UninstallString" '"$INSTDIR\uninstall.exe"'
    WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\AutomateIT!" "NoModify" 1
    WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\AutomateIT!" "NoRepair" 1
  ${Endif}

  ${If} $0 == ""
    ; Install WordClone
    File "..\..\bin\${BUILDTYPE}\WordClone.exe"  
    ExecWait '"$INSTDIR\WordClone.exe" /RegServer'
  ${EndIf}

  ${If} $1 == ""
    ; Install ExcelClone
    File "..\..\bin\${BUILDTYPE}\ExcelClone.exe"  
    ExecWait '"$INSTDIR\ExcelClone.exe" /RegServer'
  ${EndIf}

  ${If} $0 != ""
  ${AndIf} $1 != "" 
    MessageBox MB_OK|MB_ICONEXCLAMATION "Microsoft Office is already installed. AutomateIT won't be installed."
  ${ElseIf} $0 != ""
    MessageBox MB_OK|MB_ICONEXCLAMATION "Microsoft Office Word is already installed. WordClone won't be installed."
  ${ElseIf} $1 != ""
    MessageBox MB_OK|MB_ICONEXCLAMATION "Microsoft Office Excel is already installed. ExcelClone won't be installed."
  ${EndIf}

SectionEnd

Section "Start Menu Shortcuts"

  ${If} $0 == ""
  ${Orif} $1 == ""
    CreateDirectory "$SMPROGRAMS\AutomateIT!"
    CreateShortCut "$SMPROGRAMS\AutomateIT!\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  ${Endif}

SectionEnd


Section "Uninstall"

  ${If} $0 == ""
  ${Orif} $1 == ""
    ExecWait '"$INSTDIR\WordClone.exe" /UnRegServer'
    ExecWait '"$INSTDIR\ExcelClone.exe" /UnRegServer'
    DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\AutomateIT!"
    Delete "$SMPROGRAMS\AutomateIT!\*.*"
    RMDir "$SMPROGRAMS\AutomateIT!"
    Delete $INSTDIR\*.*
    RMDir $INSTDIR
  ${Endif}

SectionEnd