/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "OOCell.h"

using namespace AutomateIT::Utils;
using namespace AutomateIT::OpenOfficeWrapper;

COOCell::COOCell()
{
}

COOCell::~COOCell()
{
}

HRESULT COOCell::Initialize( IDispatchPtr dispatch )
{
    m_pdCell = dispatch;
    return S_OK;
}

HRESULT COOCell::GetFormula( VARIANT* pvFormula )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdCell, L"getFormula", 0); 
    CHECKERROR;
    (*pvFormula) = result;
    return hr;
}

HRESULT COOCell::SetFormula( VARIANT vFormula )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdCell, L"setFormula", 1, CComVariant(vFormula)); 
    CHECKERROR;
    return hr;
}

HRESULT COOCell::get_FormulaLocal( VARIANT* pvFormula )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdCell, L"FormulaLocal", 0); 
    CHECKERROR;
    (*pvFormula) = result;
    return hr;
}

HRESULT COOCell::put_FormulaLocal( VARIANT vFormula )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdCell, L"FormulaLocal", 1, CComVariant(vFormula)); 
    CHECKERROR;
    return hr;
}

HRESULT COOCell::ClearContents( int iValue )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdCell, L"clearContents", 1, CComVariant(iValue)); 
    CHECKERROR;
    return hr;
}

