/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/


#ifndef _OO_DOCUMENT_H_
#define _OO_DOCUMENT_H_

#include "AutoWrapper.h"
#include "IDispatchWrapper.h"
#include "OOStyleFamilies.h"

#include <atlcomcli.h>

using namespace ATL;

namespace AutomateIT
{
	namespace OpenOfficeWrapper
	{
		class COOApplication;

        class ATL_NO_VTABLE COODocument : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public IUnknown
		{
		public:

            BEGIN_COM_MAP(COODocument)
                COM_INTERFACE_ENTRY(IUnknown)
            END_COM_MAP( )


			COODocument();
			virtual ~COODocument();

            HRESULT Initialize(COOApplication* pParentApplication, IDispatchPtr pdDoc);

			HRESULT SaveFile(CComVariant vFileName, CComVariant vFormatName);
            HRESULT Save();
			HRESULT Close();

            HRESULT Activate();
			
            COOApplication* GetApplication() const;


            HRESULT GetStyleFamilies(COOStyleFamilies** ppStyleFamilies);

            HRESULT SetVisible(bool bVisible);
            HRESULT GetVisible(bool* pbVisible);

            HRESULT GetFrame(IDispatch** pdFrame);

            IDispatchPtr GetIDispatchInstance() const;



		private:
            COOApplication* m_pApp;
            IDispatchPtr m_pInstance;
		};

        typedef CComObject<COODocument> COODocumentObject;
        typedef CComPtr<COODocument> COODocumentPtr;

	}
}

#endif //_OO_DOCUMENT_H_
