
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _OO_NUMBER_FORMATS_H_
#define _OO_NUMBER_FORMATS_H_

#pragma once

#include "IDispatchWrapper.h"

namespace AutomateIT
{
    namespace OpenOfficeWrapper
    {
        class COOCharLocale;

        class ATL_NO_VTABLE COONumberFormats : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public IUnknown
        {
        public:

            BEGIN_COM_MAP(COONumberFormats)
                COM_INTERFACE_ENTRY(IUnknown)
            END_COM_MAP( )

            COONumberFormats();
            virtual ~COONumberFormats();

            HRESULT Initialize(IDispatchPtr dispatch);

            HRESULT QueryKey(BSTR bstrFormat, COOCharLocale* pLocale, bool bVal, int* piKey);
            HRESULT AddNew(BSTR bstrFormat, COOCharLocale* pLocale, int* piKey);

            HRESULT GetByKey(int iKey, BSTR* pbstrFormat);

        private:

            IDispatchPtr m_pdNumberFormats;

        };

        typedef CComPtr<COONumberFormats> COONumberFormatsPtr;
        typedef CComObject<COONumberFormats> COONumberFormatsObject;

    }
}

#endif // _OO_NUMBER_FORMATS_H_
