/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "OORangeAddress.h"

using namespace AutomateIT::Utils;
using namespace AutomateIT::OpenOfficeWrapper;

COORangeAddress::COORangeAddress()
{
}

COORangeAddress::~COORangeAddress()
{
}

HRESULT COORangeAddress::Initialize( IDispatchPtr dispatch )
{
    m_pdRangeAddress = dispatch;
    return S_OK;
}

HRESULT COORangeAddress::get_StartRow( long* plValue )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdRangeAddress, L"StartRow", 0);
    CHECKERROR;

    hr = result.ChangeType(VT_I4);
    CHECKERROR;

    (*plValue) = result.intVal;
    return hr;
}

HRESULT COORangeAddress::get_StartColumn( long* plValue )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdRangeAddress, L"StartColumn", 0);
    CHECKERROR;

    hr = result.ChangeType(VT_I4);
    CHECKERROR;

    (*plValue) = result.intVal;
    return hr;
}

HRESULT COORangeAddress::get_EndRow( long* plValue )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdRangeAddress, L"EndRow", 0);
    CHECKERROR;

    hr = result.ChangeType(VT_I4);
    CHECKERROR;

    (*plValue) = result.intVal;
    return hr;
}

HRESULT COORangeAddress::get_EndColumn( long* plValue )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdRangeAddress, L"EndColumn", 0);
    CHECKERROR;

    hr = result.ChangeType(VT_I4);
    CHECKERROR;

    (*plValue) = result.intVal;
    return hr;
}

HRESULT AutomateIT::OpenOfficeWrapper::COORangeAddress::get_Sheet( long* plValue )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdRangeAddress, L"Sheet", 0);
    CHECKERROR;

    hr = result.ChangeType(VT_I4);
    CHECKERROR;

    (*plValue) = result.intVal;
    return hr;
}