/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "OORows.h"

using namespace AutomateIT::Utils;
using namespace AutomateIT::OpenOfficeWrapper;

COORows::COORows()
{
}

COORows::~COORows()
{
}

HRESULT COORows::Initialize( IDispatchPtr dispatch )
{
    m_pdRows = dispatch;
    return S_OK;
}

HRESULT COORows::get_Height( int* piHeight )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdRows, L"Height", 0);
    CHECKERROR;
    (*piHeight) = result.intVal;
    return hr;
}

HRESULT COORows::put_Height( int iHeight )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdRows, L"Height", 1, CComVariant(iHeight));
    CHECKERROR;
    return hr;
}

HRESULT COORows::GetByIndex(int index, COORow** ppRow)
{
    TRACINGMETHOD;

    CComVariant result;
    hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdRows, L"getByIndex", 1, CComVariant(index));
    CHECKERROR;
    IDispatch* pdispRow = result.pdispVal;

    COORowObject* pRowObj(NULL);
    hr = COORowObject::CreateInstance(&pRowObj);
    CHECKERROR;

    COORowPtr pRowPtr(pRowObj);
    hr = pRowPtr->Initialize(pdispRow);
    CHECKERROR;

    (*ppRow) = pRowPtr;
    (*ppRow)->AddRef();

    return S_OK;
}


HRESULT COORows::RemoveByIndex( long index, long count )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdRows, L"removeByIndex", 2, CComVariant(index), CComVariant(count));
    CHECKERROR;
    return hr;
}

HRESULT COORows::InsertByIndex( long index, long count )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdRows, L"insertByIndex", 2, CComVariant(index), CComVariant(count));
    CHECKERROR;
    return hr;
}

