
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

/*
	CApplication class implements methods of Application Word object.
	The main purpose of this clas is to retreive WordBasic object.
*/

#include "stdafx.h"
#include "Application.h"

using namespace AutomateIT;
using namespace AutomateIT::WordClone;

CApplication::CApplication() 
{
    TRACINGMETHOD;
}

CApplication::~CApplication()
{
    TRACINGMETHOD;
}

// get_Version property, always return "11.0" version
STDMETHODIMP CApplication::get_Version(BSTR *pVersion)
{
    TRACINGMETHOD;
    if (pVersion == NULL)
    {
        return E_POINTER;
    }

    *pVersion = ::SysAllocString(OLESTR("11.0"));

    return S_OK;
}

// get_WordBasic method, create and return IDispatch for WordBasic object
STDMETHODIMP CApplication::get_WordBasic(IDispatch **ppWordBasic)
{
    TRACINGMETHOD;

    if (ppWordBasic == NULL)
    {
        return E_POINTER;
    }


    HRESULT hres = ::CoCreateInstance(CLSID_WordBasic, 
                                    NULL, 
                                    CLSCTX_INPROC, 
                                    IID_IDispatch, 
                                    (void**)ppWordBasic);
    return hres;
}

// Quit, do nothing:)
STDMETHODIMP CApplication::Quit(VARIANT* SaveChanges, VARIANT* OriginalFormat, VARIANT* RouteDocument)
{
    TRACINGMETHOD;
    return S_OK;
}

STDMETHODIMP CApplication::get_Application(IApplication** app)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Creator(long* creator)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Parent(LPDISPATCH* parent)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Name(BSTR* name)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Documents(Documents** docs)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Windows(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ActiveDocument(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ActiveWindow(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Selection(Selection** selection)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_RecentFiles(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_NormalTemplate(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_System(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_AutoCorrect(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_FontNames(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_LandscapeFontNames(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_PortraitFontNames(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Languages(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Assistant(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Browser(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_FileConverters(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_MailingLabel(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Dialogs(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_CaptionLabels(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_AutoCaptions(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_AddIns(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Visible(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_Visible(VARIANT_BOOL prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ScreenUpdating(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_ScreenUpdating(VARIANT_BOOL prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_PrintPreview(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_PrintPreview(VARIANT_BOOL prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Tasks(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_DisplayStatusBar(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_DisplayStatusBar(VARIANT_BOOL prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_SpecialMode(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_UsableWidth(long* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_UsableHeight(long* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_MathCoprocessorAvailable(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_MouseAvailable(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_International(WdInternationalIndex Index, VARIANT* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Build(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_CapsLock(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_NumLock(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_UserName(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_UserName(BSTR prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_UserInitials(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_UserInitials(BSTR prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_UserAddress(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_UserAddress(BSTR prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_MacroContainer(LPDISPATCH* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_DisplayRecentFiles(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_DisplayRecentFiles(VARIANT_BOOL prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_CommandBars(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_SynonymInfo(BSTR Word, VARIANT* LanguageID, IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_VBE(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_DefaultSaveFormat(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_DefaultSaveFormat(BSTR prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ListGalleries(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ActivePrinter(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_ActivePrinter(BSTR prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Templates(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_CustomizationContext(LPDISPATCH* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_CustomizationContext(LPDISPATCH prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_KeyBindings(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_KeysBoundTo(WdKeyCategory KeyCategory, BSTR Command, VARIANT* CommandParameter, IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_FindKey(long KeyCode, VARIANT* KeyCode2, IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Caption(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_Caption(BSTR prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Path(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_DisplayScrollBars(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_DisplayScrollBars(VARIANT_BOOL prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_StartupPath(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_StartupPath(BSTR prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_BackgroundSavingStatus(long* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_BackgroundPrintingStatus(long* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Left(long* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_Left(long prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Top(long* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_Top(long prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_Width(long prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Height(long* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_Height(long prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_WindowState(WdWindowState* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_WindowState(WdWindowState prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_DisplayAutoCompleteTips(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_DisplayAutoCompleteTips(VARIANT_BOOL prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Options(Options** options)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_DisplayAlerts(WdAlertLevel* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_DisplayAlerts(WdAlertLevel prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_CustomDictionaries(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_PathSeparator(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_StatusBar(BSTR)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_DisplayScreenTips(VARIANT_BOOL prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_EnableCancelKey(WdEnableCancelKey* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_EnableCancelKey(WdEnableCancelKey prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_MailSystem(WdMailSystem* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_DefaultTableSeparator(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_DefaultTableSeparator(BSTR prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ShowVisualBasicEditor(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_ShowVisualBasicEditor(VARIANT_BOOL prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_BrowseExtraFileTypes(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_BrowseExtraFileTypes(BSTR prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_IsObjectValid(LPDISPATCH Object, VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_HangulHanjaDictionaries(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_MailMessage(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_FocusInMailHeader(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::ScreenRefresh()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::PrintOutOld(VARIANT* Background, VARIANT* Append, VARIANT* Range, VARIANT* OutputFileName, VARIANT* From, VARIANT* To, VARIANT* Item, VARIANT* Copies, VARIANT* Pages, VARIANT* PageType, VARIANT* PrintToFile, VARIANT* Collate, VARIANT* FileName, VARIANT* ActivePrinterMacGX, VARIANT* ManualDuplexPrint)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::LookupNameProperties(BSTR Name)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::SubstituteFont(BSTR UnavailableFont, BSTR SubstituteFont)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::Repeat(VARIANT* Times, VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::DDEExecute(long Channel, BSTR Command)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::DDEInitiate(BSTR App, BSTR Topic, long* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::DDEPoke(long Channel, BSTR Item, BSTR Data)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::DDERequest(long Channel, BSTR Item, BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::DDETerminate(long Channel)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::DDETerminateAll()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::BuildKeyCode(WdKey Arg1, VARIANT* Arg2, VARIANT* Arg3, VARIANT* Arg4, long* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::KeyString(long KeyCode, VARIANT* KeyCode2, BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::OrganizerCopy(BSTR Source, BSTR Destination, BSTR Name, WdOrganizerObject Object)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::OrganizerDelete(BSTR Source, BSTR Name, WdOrganizerObject Object)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::OrganizerRename(BSTR Source, BSTR Name, BSTR NewName, WdOrganizerObject Object)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::AddAddress(SAFEARRAY** TagID, SAFEARRAY** Value)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::GetAddress(VARIANT* Name, VARIANT* AddressProperties, VARIANT* UseAutoText, VARIANT* DisplaySelectDialog, VARIANT* SelectDialog, VARIANT* CheckNamesDialog, VARIANT* RecentAddressesChoice, VARIANT* UpdateRecentAddresses, BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::CheckGrammar(BSTR String, VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::CheckSpelling(BSTR Word, VARIANT* CustomDictionary, VARIANT* IgnoreUppercase, VARIANT* MainDictionary, VARIANT* CustomDictionary2, VARIANT* CustomDictionary3, VARIANT* CustomDictionary4, VARIANT* CustomDictionary5, VARIANT* CustomDictionary6, VARIANT* CustomDictionary7, VARIANT* CustomDictionary8, VARIANT* CustomDictionary9, VARIANT* CustomDictionary10, VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::ResetIgnoreAll()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::GetSpellingSuggestions(BSTR Word, VARIANT* CustomDictionary, VARIANT* IgnoreUppercase, VARIANT* MainDictionary, VARIANT* SuggestionMode, VARIANT* CustomDictionary2, VARIANT* CustomDictionary3, VARIANT* CustomDictionary4, VARIANT* CustomDictionary5, VARIANT* CustomDictionary6, VARIANT* CustomDictionary7, VARIANT* CustomDictionary8, VARIANT* CustomDictionary9, VARIANT* CustomDictionary10, IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::GoBack()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::Help(VARIANT* HelpType)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::AutomaticChange()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::ShowMe()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::HelpTool()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::NewWindow(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::ListCommands(VARIANT_BOOL ListAllCommands)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::ShowClipboard()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::OnTime(VARIANT* When, BSTR Name, VARIANT* Tolerance)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::NextLetter()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::MountVolume(BSTR Zone, BSTR Server, BSTR Volume, VARIANT* User, VARIANT* UserPassword, VARIANT* VolumePassword, short* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::CleanString(BSTR String, BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::SendFax()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::ChangeFileOpenDirectory(BSTR Path)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::RunOld(BSTR MacroName)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::GoForward()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::Move(long Left, long Top)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::Resize(long Width, long Height)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::InchesToPoints(float Inches, float* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::CentimetersToPoints(float Centimeters, float* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::MillimetersToPoints(float Millimeters, float* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::PicasToPoints(float Picas, float* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::LinesToPoints(float Lines, float* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::PointsToInches(float Points, float* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::PointsToCentimeters(float Points, float* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::PointsToMillimeters(float Points, float* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::PointsToPicas(float Points, float* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::PointsToLines(float Points, float* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::Activate()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::PointsToPixels(float Points, VARIANT* fVertical, float* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::PixelsToPoints(float Pixels, VARIANT* fVertical, float* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::KeyboardLatin()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::KeyboardBidi()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::ToggleKeyboard()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::Keyboard(VARIANT LangId, VARIANT* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::ProductCode(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::DefaultWebOptions(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::DiscussionSupport(VARIANT* Range, VARIANT* cid, VARIANT* piCSE)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::SetDefaultTheme(BSTR Name, WdDocumentMedium DocumentType)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::GetDefaultTheme(WdDocumentMedium DocumentType, BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_EmailOptions(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Language(MsoLanguageID* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_COMAddIns(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_CheckLanguage(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_CheckLanguage(VARIANT_BOOL prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_LanguageSettings(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Dummy1(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_AnswerWizard(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_FeatureInstall(MsoFeatureInstall* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_FeatureInstall(MsoFeatureInstall prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::PrintOut2000(VARIANT* Background, VARIANT* Append, VARIANT* Range, VARIANT* OutputFileName, VARIANT* From, VARIANT* To, VARIANT* Item, VARIANT* Copies, VARIANT* Pages, VARIANT* PageType, VARIANT* PrintToFile, VARIANT* Collate, VARIANT* FileName, VARIANT* ActivePrinterMacGX, VARIANT* ManualDuplexPrint, VARIANT* PrintZoomColumn, VARIANT* PrintZoomRow, VARIANT* PrintZoomPaperWidth, VARIANT* PrintZoomPaperHeight)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::Run(BSTR MacroName, VARIANT* varg1, VARIANT* varg2, VARIANT* varg3, VARIANT* varg4, VARIANT* varg5, VARIANT* varg6, VARIANT* varg7, VARIANT* varg8, VARIANT* varg9, VARIANT* varg10, VARIANT* varg11, VARIANT* varg12, VARIANT* varg13, VARIANT* varg14, VARIANT* varg15, VARIANT* varg16, VARIANT* varg17, VARIANT* varg18, VARIANT* varg19, VARIANT* varg20, VARIANT* varg21, VARIANT* varg22, VARIANT* varg23, VARIANT* varg24, VARIANT* varg25, VARIANT* varg26, VARIANT* varg27, VARIANT* varg28, VARIANT* varg29, VARIANT* varg30, VARIANT* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::PrintOut(VARIANT* Background, VARIANT* Append, VARIANT* Range, VARIANT* OutputFileName, VARIANT* From, VARIANT* To, VARIANT* Item, VARIANT* Copies, VARIANT* Pages, VARIANT* PageType, VARIANT* PrintToFile, VARIANT* Collate, VARIANT* FileName, VARIANT* ActivePrinterMacGX, VARIANT* ManualDuplexPrint, VARIANT* PrintZoomColumn, VARIANT* PrintZoomRow, VARIANT* PrintZoomPaperWidth, VARIANT* PrintZoomPaperHeight)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_AutomationSecurity(MsoAutomationSecurity* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_AutomationSecurity(MsoAutomationSecurity prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_FileDialog(MsoFileDialogType FileDialogType, IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_EmailTemplate(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_EmailTemplate(BSTR prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ShowWindowsInTaskbar(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_ShowWindowsInTaskbar(VARIANT_BOOL prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_NewDocument(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ShowStartupDialog(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_ShowStartupDialog(VARIANT_BOOL prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_AutoCorrectEmail(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_TaskPanes(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_DefaultLegalBlackline(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_DefaultLegalBlackline(VARIANT_BOOL prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::Dummy2(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_SmartTagRecognizers(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_SmartTagTypes(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_XMLNamespaces(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::PutFocusInMailHeader()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ArbitraryXMLSupportAvailable(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_OperatingSystem(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ProcessorType(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_FreeDiskSpace(long* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Country(WdCountry* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_LanguageDesignation(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_HorizontalResolution(long* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_VerticalResolution(long* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ProfileString(BSTR Section, BSTR Key, BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_ProfileString(BSTR Section, BSTR Key, BSTR prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_PrivateProfileString(BSTR FileName, BSTR Section, BSTR Key, BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_PrivateProfileString(BSTR FileName, BSTR Section, BSTR Key, BSTR prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_MathCoprocessorInstalled(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ComputerType(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_MacintoshName(BSTR* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_QuickDrawInstalled(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Cursor(WdCursorType* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::put_Cursor(WdCursorType prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::MSInfo()
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::Connect(BSTR Path, VARIANT* Drive, VARIANT* Password)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_CountryRegion(WdCountry* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_VBProjects(IDispatch** lppptReturn)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_CodePanes(IDispatch** ppCodePanes)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Events(IDispatch** ppevtEvents)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ActiveVBProject(IDispatch** lppptReturn)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::putref_ActiveVBProject(IDispatch* lppptReturn)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_SelectedVBComponent(IDispatch** lppscReturn)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_MainWindow(IDispatch** ppwin)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_ActiveCodePane(IDispatch** ppCodePane)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::putref_ActiveCodePane(IDispatch* ppCodePane)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Addins(IDispatch** lpppAddIns)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_Width(long* width)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_MAPIAvailable(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_DisplayScreenTips(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_UserControl(VARIANT_BOOL* prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::get_FileSearch(IDispatch** prop)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::EnumConnectionPoints(IEnumConnectionPoints** ppEnum)
{
	TRACINGMETHOD;
	return S_OK;
}

STDMETHODIMP CApplication::FindConnectionPoint(REFIID riid, IConnectionPoint** ppCP)
{
	TRACINGMETHOD;
	return S_OK;
}